﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using C1.WPF.DataGrid;
using C1.WPF;
using System.Collections.ObjectModel;
using System.Threading;
using C1.WPF.Theming.ExpressionDark;

namespace Wpf_C1ProgressIndicator
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ObservableCollection<Data> data = new ObservableCollection<Data>();
        public MainWindow()
        {
            InitializeComponent();
            C1.WPF.Theming.ExpressionDark.C1ThemeExpressionDark d = new C1ThemeExpressionDark();
            d.Apply(this);
            d.Apply(c1Chart);          
        }

        private void Grid_Loaded_1(object sender, RoutedEventArgs e)
        {
            for (int i = 0; i <= 20; i++)
            {
                data.Add(new Data() { ID = i, Name = "ABC" + i, Department = "Dept" + i, Location = "20130" + i, Permanent = true });
            }
            this.DataContext = data;
            c1DataGrid.Visibility = Visibility.Hidden;
            ShowProgressIndicator("Loading C1DataGrid....");
        }
        public void ShowProgressIndicator(String msg)
        {
            var w = new C1Window();
            StackPanel MyStackPanel = new StackPanel();
            TextBlock MyPercentProgress = new TextBlock();
            C1ProgressIndicator pi = new C1ProgressIndicator();
            pi.Header = msg;
            pi.UseLayoutRounding = true;
            pi.Foreground = new SolidColorBrush(Colors.Green);
            MyStackPanel.Children.Add(MyPercentProgress);
            MyStackPanel.Children.Add(pi);
            w.Content = MyStackPanel;
            w.Width = 300;
            w.Height = 150;
            w.CenterOnScreen();
            w.ShowModal();
            Thread t1 = new Thread(new ThreadStart(() =>
            {
                for (int i = 1; i <= 100; i++)
                {
                    this.Dispatcher.BeginInvoke(new Action(() =>
                    {
                        int counter = i;
                        string myString = counter.ToString();
                        MyPercentProgress.Text = myString + "% Data Loaded";
                        pi.IsActive = true;
                        if (counter == 100)
                        {
                            w.Close();
                            this.c1Chart.Visibility = Visibility.Visible;
                            this.c1DataGrid.Visibility = Visibility.Visible;
                        }
                    }));
                    Thread.Sleep(50);
                }
            }));
            t1.Start();
            pi.IsActive = false;
        }

        private void dgTab_GotFocus_1(object sender, RoutedEventArgs e)
        {
            c1DataGrid.Visibility = Visibility.Hidden;
            ShowProgressIndicator("Loading C1DataGrid....");
        }

        private void chartTab_GotFocus_1(object sender, RoutedEventArgs e)
        {
            c1Chart.Visibility = Visibility.Hidden;
            ShowProgressIndicator("Loading C1Chart....");
        }
    }
   
    public class Data
    {
        public int ID { get; set; }
        public string Name { get; set; }
        public string Department { get; set; }
        public string Location { get; set; }
        public bool Permanent { get; set; }
    }
}

